Package org.apache.bcel.classfile

# Class InnerClasses

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.InnerClasses

All Implemented Interfaces:
  `Cloneable`, `Iterable<InnerClass>`, `Node`

public final class InnerClasses extends Attribute implements Iterable<InnerClass>
This class is derived from Attribute and denotes that this class is an Inner class of another. to the source file of this class. It is instantiated from the Attribute.readAttribute() method.

See Also:
  - `Attribute`

- ## Field Summary

  ### Fields inherited from class org.apache.bcel.classfile.Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `InnerClasses(int nameIndex, int length, InnerClass[] innerClasses, ConstantPool constantPool)`
  `InnerClasses(InnerClasses c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  `void`
  `dump(DataOutputStream file)`
  Dump source file attribute to file stream in binary format.
  `InnerClass[]`
  `getInnerClasses()`
  `Iterator<InnerClass>`
  `iterator()`
  `void`
  `setInnerClasses(InnerClass[] innerClasses)`
  `String`
  `toString()`

  ### Methods inherited from class org.apache.bcel.classfile.Attribute

  `addAttributeReader, addAttributeReader, clone, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class java.lang.Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.lang.Iterable

  `forEach, spliterator`

- ## Constructor Details

  - ### InnerClasses

    public InnerClasses(InnerClasses c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use clone() for a physical copy.
    Parameters:
      `c` - Source to copy.

  - ### InnerClasses

    public InnerClasses(int nameIndex, int length, InnerClass[] innerClasses, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8
      `length` - Content length in bytes
      `innerClasses` - array of inner classes attributes
      `constantPool` - Array of constants

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute

  - ### dump

    public void dump(DataOutputStream file) throws IOException
    Dump source file attribute to file stream in binary format.
    Overrides:
      `dump` in class `Attribute`
    Parameters:
      `file` - Output file stream
    Throws:
      `IOException` - if an I/O error occurs.

  - ### getInnerClasses

    public InnerClass[] getInnerClasses()
    Returns:
      array of inner class "records"

  - ### iterator

    public Iterator<InnerClass> iterator()
    Specified by:
      `iterator` in interface `Iterable<InnerClass>`

  - ### setInnerClasses

    public void setInnerClasses(InnerClass[] innerClasses)
    Parameters:
      `innerClasses` - the array of inner classes

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation.